# File: BaseTabajara.py
# 
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil)
# Generator: ArchGenXML Version 1.4.0-beta2 devel 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *



from Products.Tabajara.config import *
##code-section module-header #fill in your manual code here
from Products.Tabajara.Widget import TreeReferenceWidget
from Products.CMFCore.utils import getToolByName
from Products.Tabajara.util import getTreeRoot
##/code-section module-header

schema=Schema((

    ReferenceField('node',
        root_node= 'getTreeRoot',
        multiValued=1,
        relationship='node',
        tabajara=1,
        allowed_types=('TreeNode',),
        widget=TreeReferenceWidget
        (
            label="Tabajara Category",
            visible= {'view' : 'invisible', 'edit' : 'visible'},
            label_msgid='Tabajara_label_node',
            description_msgid='Tabajara_help_node',
            i18n_domain='Tabajara',
        )
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

BaseTabajara_schema = schema

##code-section after-schema #fill in your manual code here
BaseTabajaraSchema = schema
##/code-section after-schema

class BaseTabajara:
    """
    Base Class for Tabajara Content Types
    """
    security = ClassSecurityInfo()
    __implements__ = ()


    allowed_content_types      = []
    schema = BaseTabajara_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declareProtected("View", 'getAssociatedMembers')
    def getAssociatedMembers(self, 
                             content_relationship = 'node', 
                             member_relationship = 'member_node',
                             member_query = {}, 
                             filter_email = 1, 
                             filter_role = None):
        """
        Return the Members associated with the content
        """

        mc = getToolByName(self, 'member_catalog')
        CR = content_relationship
        MR = member_relationship
        l1 = self.getRefs(CR)
        sr = mc.searchResults(member_query)
        ret = [] 
        for r in sr:
            member = r.getObject()
            if filter_email and not member.getEmail() or \
               filter_role and not filter_role in member.getRoles():
                continue
            l2 = member.getRefs(MR)
            for i in l1:
                if i in l2:
                    ret.append(member)
                    break
        return ret


    #manually created methods

    def getTreeRoot(self):
        """ Return the tree root, defined by a property or something
            else acquired in the context of the TreeMenuManager
            tool. If this approach does not work for your needs
            (e.g. when we have more than one Taxonomy Tree, this
            method should be rewritten.
        """

        return getTreeRoot(self)


# end of class BaseTabajara

##code-section module-footer #fill in your manual code here
##/code-section module-footer



