# File: TabajaraMember.py
# 
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil)
# Generator: ArchGenXML Version 1.4.0-beta2 devel 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *



# imports needed by CMFMember
from Products.CMFMember import Member as BaseMember
from Products.CMFMember.MemberPermissions import \
        VIEW_PUBLIC_PERMISSION, EDIT_ID_PERMISSION, \
        EDIT_PROPERTIES_PERMISSION, VIEW_OTHER_PERMISSION,  \
        VIEW_SECURITY_PERMISSION, EDIT_PASSWORD_PERMISSION, \
        EDIT_SECURITY_PERMISSION, MAIL_PASSWORD_PERMISSION, \
        ADD_MEMBER_PERMISSION
from AccessControl import ModuleSecurityInfo
from Products.Tabajara.config import *

# Generate the addTabajaraMember method ourselves so we can do some extra
# initialization, i.e. so we can set an initial password
security = ModuleSecurityInfo('Products.Tabajara.TabajaraMember')

security.declareProtected(ADD_MEMBER_PERMISSION, 'addTabajaraMember')
def addTabajaraMember(self, id, **kwargs):
    o = TabajaraMember(id)
    self._setObject(id, o)
    o = getattr(self, id)
    o.initializeArchetype(**kwargs)
    o.getUser()
    o._setPassword(o._generatePassword())

##code-section module-header #fill in your manual code here
from Products.Tabajara.Widget import TreeReferenceWidget
from Products.Tabajara.util import getTreeRoot
if use_cmfmember_1_1:
    from Products.CMFMember.api import member_schema
##/code-section module-header

schema=Schema((

    ReferenceField('member_node',
        regfield=0,
        read_permission= VIEW_PUBLIC_PERMISSION,
        relationship='member_node',
        tabajara=1,
        widget=TreeReferenceWidget
        (
            label="Tabajara Member Category",
            visible= {'view' : 'invisible', 'edit' : 'visible'},
            label_msgid='Tabajara_label_member_node',
            description_msgid='Tabajara_help_member_node',
            i18n_domain='Tabajara',
        ),
        multiValued=1,
        allowed_types=('TreeNode',),
        write_permission= EDIT_PROPERTIES_PERMISSION,
        root_node= 'getTreeRoot'
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

TabajaraMember_schema = BaseMember.id_schema + \
    schema + \
    BaseMember.contact_schema + \
    BaseMember.plone_schema + \
    BaseMember.security_schema + \
    BaseMember.login_info_schema + \
    ExtensibleMetadata.schema

##code-section after-schema #fill in your manual code here
schema_tabajara = schema
##/code-section after-schema

class TabajaraMember(BaseMember.Member):
    """
    TabajaraMember
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseMember.Member,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'TabajaraMember'

    meta_type                  = 'TabajaraMember'
    portal_type                = 'TabajaraMember'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'TabajaraMember.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "TabajaraMember"
    typeDescMsgId              = 'description_edit_tabajaramember'

    schema = TabajaraMember_schema

    ##code-section class-header #fill in your manual code here
    if use_cmfmember_1_1:
        schema = member_schema + \
                 ExtensibleMetadata.schema + \
                 schema_tabajara
    ##/code-section class-header


    #Methods
    #manually created methods

    def getTreeRoot(self):
        """ Return the tree root, defined by a property or something
            else acquired in the context of the TreeMenuManager
            tool. If this approach does not work for your needs
            (e.g. when we have more than one Taxonomy Tree, this
            method should be rewritten.
        """

        return getTreeRoot(self)



registerType(TabajaraMember,PROJECTNAME)
# end of class TabajaraMember

##code-section module-footer #fill in your manual code here
##/code-section module-footer



