# File: TreeGenerator.py
# 
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil)
# Generator: ArchGenXML Version 1.4.0-beta2 devel 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *



from Products.Tabajara.config import *

from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
LEVELS_SEPARATOR = "."
##/code-section module-header

schema=Schema((
    LinesField('nodes_buffer',
        widget=LinesWidget(
            label="Nodes Buffer",
            label_msgid='Tabajara_label_nodes_buffer',
            description_msgid='Tabajara_help_nodes_buffer',
            i18n_domain='Tabajara',
        )
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

TreeGenerator_schema = BaseSchema + \
    schema

##code-section after-schema #fill in your manual code here
from Products.CMFCore.utils import getToolByName
##/code-section after-schema

class TreeGenerator(UniqueObject,BaseContent):
    """
    Tree Generator
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'TreeGenerator'

    meta_type                  = 'TreeGenerator'
    portal_type                = 'TreeGenerator'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'TreeGenerator.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "TreeGenerator"
    typeDescMsgId              = 'description_edit_treegenerator'
    #toolicon                   = 'TreeGenerator.gif'

    schema = TreeGenerator_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseContent.__init__(self,'portal_treegenerator')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer



    #Methods

    security.declarePublic('generate')
    def generate(self):
        """
        Generate Tree Menu based on Nodes Buffer content.
        """

        self._create_tree()


    #manually created methods

    def _create_tree(self, id = 'taxonomy'):

        pu = getToolByName(self, 'portal_url')
        portal = pu.getPortalObject()

	try:
            portal.invokeFactory('TreeNode', id)
	except:
	    pass
	r = getattr(portal, id)
	r.setTitle(id.capitalize())
        r.reindexObject()

        t = self._parseTree(self.getNodes_buffer())

        t.sort()

        for levels, title in t:
            l = levels.split(LEVELS_SEPARATOR)
            obj = r
            for i in range(len(l)):
                new_id = LEVELS_SEPARATOR.join(l[:i + 1])
                new_obj = getattr(obj, new_id, None)
                if new_obj is None:
                    obj.invokeFactory('TreeNode', new_id)
                    new_obj = getattr(obj, new_id)
                    new_obj.setTitle(title)
                    new_obj.reindexObject()
                else:
                    obj = new_obj


    def _parseTree(self, t):
        ret = []
        for l in t:
            c = l.split(' ')
            c1 = c[0]
            c2 = ' '.join(c[1:])
            ret.append((c1, c2))
        return ret



registerType(TreeGenerator,PROJECTNAME)
# end of class TreeGenerator

##code-section module-footer #fill in your manual code here
##/code-section module-footer



