# File: TreeMenu.py
# 
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil)
# Generator: ArchGenXML Version 1.4.0-beta2 devel 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *



from Products.Tabajara.config import *
##code-section module-header #fill in your manual code here
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema=Schema((
    IntegerField('levels',
        default="3",
        widget=IntegerWidget(
            label='Levels',
            label_msgid='Tabajara_label_levels',
            description_msgid='Tabajara_help_levels',
            i18n_domain='Tabajara',
        )
    ),

    StringField('style',
        default= 'H',
        widget=SelectionWidget
        (
            label='Style',
            label_msgid='Tabajara_label_style',
            description_msgid='Tabajara_help_style',
            i18n_domain='Tabajara',
        ),
        required=1,
        vocabulary= 'voc_style'
    ),

    BooleanField('show_root',
        widget=BooleanWidget(
            label="Show Root",
            label_msgid='Tabajara_label_show_root',
            description_msgid='Tabajara_help_show_root',
            i18n_domain='Tabajara',
        )
    ),

    StringField('html_cache',
        widget=TextAreaWidget
        (
            label="HTML Cache",
            visible={'edit':'visible','view':'invisible'},
            label_msgid='Tabajara_label_html_cache',
            description_msgid='Tabajara_help_html_cache',
            i18n_domain='Tabajara',
        ),
        schemata="cache"
    ),


    ReferenceField('tree_root',
        widget=ReferenceWidget(
            label="Tree Root",
            label_msgid='Tabajara_label_tree_root',
            description_msgid='Tabajara_help_tree_root',
            i18n_domain='Tabajara',
        ),
        required=1,
        multiValued=0,
        relationship='tree_root',
        allowed_types=('TreeNode',),
        allowed_types_method="getAllowedTypesForTreeRoot"
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

TreeMenu_schema = BaseSchema + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class TreeMenu(BaseContent):
    """
    TreeMenu
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'TreeMenu'

    meta_type                  = 'TreeMenu'
    portal_type                = 'TreeMenu'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'TreeMenu.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "TreeMenu"
    typeDescMsgId              = 'description_edit_treemenu'

    schema = TreeMenu_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declareProtected("View", 'getMenuHTML')
    def getMenuHTML(self):
        """
        Return the menu HTML code
        """
        
        return self.getHtml_cache()



    security.declareProtected("View", 'refreshMenu')
    def refreshMenu(self):
        """
        Refresh the menu HTML code slurping accross the TreeNode
        structure
        """
        
        try:
            root = self.getRefs('tree_root')[0]
        except IndexError:
            return

        ret = self._buildTree(self._extractTree(root))
        self.setHtml_cache(ret)
        return ret


    #manually created methods

    def getAllowedTypesForTreeRoot(self, instance):
        ## TODO: Refactory using ITreeNode and Factory Registry!
        return ('TreeNode', 'Unidade')   


    def voc_style(self):
        return DisplayList((('H', 'Horizontal'), ('V', 'Vertical')))


    def _extractTreeNode(self, obj):
        pu = getToolByName(self, 'portal_url')
        p = pu.getPortalObject().absolute_url()
        refs = obj.getRefs('content')
        t, u = obj.Title(), refs and refs[0].getPhysicalPath() or obj.getPhysicalPath()
        empty_a = getattr(obj.aq_base, 'empty_a', None)
        if empty_a: t = ''
        text_only = getattr(obj.aq_base, 'text_only', None)
        if text_only: 
            u = ''
        else:
            if refs:
                u = p + '/' + '/'.join(u[2:])   ## TODO: FIXME!!!
            else:
                navigation_context = getattr(obj, 'navigation_context', '')
                u = p + navigation_context + '/' + '/'.join(u[2:])   ## TODO: FIXME!!!
        tag_id = getattr(obj.aq_base, 'tag_id', '')
        return (u, t, tag_id)


    def _extractTree(self, root, levelNumber = 0):
        ret = ()
        if levelNumber == 0 and self.getShow_root():
            return ((self._extractTreeNode(root), 
                     self._extractTree(root, levelNumber = levelNumber + 1)),)
        if levelNumber > self.getLevels():
            return ret
        for obj in root.getChildNodes():
            ret += ((self._extractTreeNode(obj), 
                     self._extractTree(obj, levelNumber = levelNumber + 1)),)
        return ret


    security.declarePublic('getFreshMenuHTML')
    def getFreshMenuHTML(self):
        """
        Return the FRESH menu HTML code (performance fault here!)
        """

        try:
            root = self.getRefs('tree_root')[0]
        except IndexError:
            return
        return self._buildTree(self._extractTree(root))


    def _buildTree(self, theLevel, levelNumber = 0):
        if not self.getShow_root() and levelNumber == 0:
            levelNumber = 1
        result = '<ul class="level%d">' % levelNumber
        for level in theLevel:
            url, title, tag_id = level[0]
            class_param = level[1] != () and ' class="submenu"' or ''
            id_param = tag_id and ' id="%s"' %  tag_id or ''
            if not url:
                result += '<li%s%s>' % (class_param, id_param) + title
            else:
                result += '<li%s%s><a href="' % (class_param, id_param) + url + '">' + title + '</a>'
            if level[1] != ():
                 result += self._buildTree(level[1], levelNumber = levelNumber + 1)
        return result + '</ul>'



registerType(TreeMenu,PROJECTNAME)
# end of class TreeMenu

##code-section module-footer #fill in your manual code here
##/code-section module-footer



