# File: TreeNode.py
# 
# Copyright (c) 2005 by Weimar Desenvolvimento e Consultoria em Informatica
# Ltda (Brasil)
# Generator: ArchGenXML Version 1.4.0-beta2 devel 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Fabiano Weimar dos Santos <xiru@xiru.org>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from ITreeNode import ITreeNode


from Products.Tabajara.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

schema=Schema((
    ReferenceField('content',
        widget=ReferenceWidget
        (
            label='Content',
            label_msgid='Tabajara_label_content',
            description_msgid='Tabajara_help_content',
            i18n_domain='Tabajara',
        ),
        allowed_types_method="getAllowedTypesForTreeNode",
        relationship="content"
    ),

    StringField('external_url',
        widget=StringWidget(
            label="External URL",
            label_msgid='Tabajara_label_external_url',
            description_msgid='Tabajara_help_external_url',
            i18n_domain='Tabajara',
        ),
        schemata="external"
    ),

    StringField('external_url_target',
        default="_blank",
        widget=StringWidget(
            label="Target",
            label_msgid='Tabajara_label_external_url_target',
            description_msgid='Tabajara_help_external_url_target',
            i18n_domain='Tabajara',
        ),
        schemata="external"
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

TreeNode_schema = BaseSchema + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class TreeNode(OrderedBaseFolder):
    """
    TreeNode is a simple tree node representation, planned to build
    tree data structures based on archetypes BaseFolder objects in
    contained organization dispositions.
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(OrderedBaseFolder,'__implements__',()),) + (ITreeNode,)


    # This name appears in the 'add' box
    archetype_name             = 'TreeNode'

    meta_type                  = 'TreeNode'
    portal_type                = 'TreeNode'
    allowed_content_types      = ['TreeNode']
    filter_content_types       = 1
    global_allow               = 1
    allow_discussion           = 0
    #content_icon               = 'TreeNode.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "TreeNode"
    typeDescMsgId              = 'description_edit_treenode'

    actions =  (


       {'action':      "string:$object_url/node_view",
        'category':    "object",
        'id':          'view',
        'name':        'node_view',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },


    )

    schema = TreeNode_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #methods from Interface ITreeNode

    security.declareProtected("View", 'getRootNode')
    def getRootNode(self):
        """
        Return the tree root object instance.
        """

        obj = self
        while obj.getParentNode() is not None:
            obj = obj.aq_parent
        return obj



    security.declareProtected("View", 'getParentNode')
    def getParentNode(self):
        """
        Return the tree parent node object instance.
        """
       
        ## TODO: Bad style. Refactory using ITreeNode!
        if hasattr(self, 'aq_parent') and \
           self.aq_parent.portal_type == self.meta_type: 
            return self.aq_parent



    security.declareProtected("View", 'getAllParentNodes')
    def getAllParentNodes(self):
        """
        Return a list of object instances with the node parent until the
        root tree node.
        """
        
        ret = []
        obj = self
        while obj.getParentNode() is not None:
            obj = obj.aq_parent
            ret.append(obj)
        return ret



    security.declareProtected("View", 'getChildNodes')
    def getChildNodes(self):
        """
        Return a list of nodes inside the node.
        """
        
        ## TODO: Bad style. Refactory using ITreeNode!
        return self.objectValues([self.meta_type])



    security.declareProtected("View", 'getAssociatedContent')
    def getAssociatedContent(self):
        """
        Return the content object associated with the node.
        """
        
        try:
            return self.getRefs('content')[0]
        except IndexError:
            return None


    #manually created methods

    def getAllowedTypesForTreeNode(self, instance):
        try:
            return self.getTypesForTreeNode()
        except:
            return ('Document', 'Topic', 'Folder', 'ATDocument', 'ATTopic', 'ATFolder')



registerType(TreeNode,PROJECTNAME)
# end of class TreeNode

##code-section module-footer #fill in your manual code here
##/code-section module-footer



